.orthos_dependencies <- c(
    "tensorflow-hub==0.12.0", 
    "scipy==1.7.3",
    "requests==2.28.1", 
    "Pillow==9.2.0", 
    "h5py==3.7.0",
    "pandas==1.3.5", 
    "tensorflow==2.10.0",
    "keras==2.10.0", 
    "pydot==1.4.2", 
    "numpy==1.22.4",
    "absl-py==1.4.0",
    "aiohttp==3.8.4",
    "aiosignal==1.3.1",
    "astunparse==1.6.3",
    "async-timeout==4.0.2",
    "attrs==22.2.0",
    "blinker==1.6.2",
    "bottleneck==1.3.7",
    "brotlipy==0.7.0",
    "bzip2==1.0.8",
    "c-ares==1.18.1",
    "ca-certificates==2022.12.7",
    "cached-property==1.5.2",
    "cachetools==5.3.0",
    "cairo==1.16.0",
    "certifi==2022.12.7",
    "cffi==1.15.1",
    "charset-normalizer==2.1.1",
    "click==8.1.3",
    "cryptography==39.0.0",
    "expat==2.5.0",
    "font-ttf-dejavu-sans-mono==2.37",
    "font-ttf-inconsolata==3.000",
    "font-ttf-source-code-pro==2.038",
    "font-ttf-ubuntu==0.83",
    "fontconfig==2.14.2",
    "fonts-conda-ecosystem==1",
    "fonts-conda-forge==1",
    "freetype==2.12.1",
    "fribidi==1.0.10",
    "frozenlist==1.3.3",
    "gast==0.4.0",
    "gettext==0.21.1",
    "giflib==5.2.1",
    "google-auth==2.17.3",
    "google-auth-oauthlib==0.4.6",
    "google-pasta==0.2.0",
    "gts==0.7.6",
    "hdf5==1.12.2",
    "idna==3.4",
    "importlib-metadata==6.6.0",
    "jpeg==9e",
    "keras-preprocessing==1.1.2",
    "krb5==1.20.1",
    "lcms2==2.15",
    "lerc==4.0.0",
    "libabseil==20220623.0",
    "libaec==1.0.6",
    "libblas==3.9.0",
    "libcblas==3.9.0",
    "libdeflate==1.17",
    "libexpat==2.5.0",
    "libffi==3.4.2",
    "libgd==2.3.3",
    "libglib==2.76.2",
    "libiconv==1.17",
    "liblapack==3.9.0",
    "libopenblas==0.3.21",
    "libpng==1.6.39",
    "libsqlite==3.40.0",
    "libssh2==1.10.0",
    "libtiff==4.5.0",
    "libxcb==1.13",
    "libxml2==2.10.3",
    "libzlib==1.2.13",
    "markdown==3.4.3",
    "markupsafe==2.1.2",
    "multidict==6.0.4",
    "nomkl==1.0",
    "oauthlib==3.2.2",
    "openjpeg==2.5.0",
    "openssl==1.1.1t",
    "opt_einsum==3.3.0",
    "packaging==23.1",
    "pcre2==10.40",
    "pip==23.1.1",
    "pthread-stubs==0.4",
    "pyasn1==0.4.8",
    "pyasn1-modules==0.2.7",
    "pycparser==2.21",
    "pyjwt==2.6.0",
    "pyopenssl==23.1.1",
    "pyparsing==3.0.9",
    "pysocks==1.7.1",
    "python==3.8.13",
    "python-dateutil==2.8.2",
    "python-flatbuffers==23.1.21",
    "python_abi==3.8",
    "pytz==2023.3",
    "pyu2f==0.1.5",
    "re2==2022.06.01",
    "requests-oauthlib==1.3.1",
    "rsa==4.9",
    "setuptools==67.7.1",
    "six==1.16.0",
    "snappy==1.1.10",
    "sqlite==3.40.0",
    "tensorboard==2.10.1",
    "tensorboard-data-server==0.6.1",
    "tensorboard-plugin-wit==1.8.1",
    "tensorflow-base==2.10.0",
    "tensorflow-estimator==2.10.0",
    "termcolor==2.3.0",
    "tk==8.6.12",
    "typing_extensions==4.5.0",
    "urllib3==1.26.15",
    "werkzeug==2.2.3",
    "wheel==0.40.0",
    "wrapt==1.15.0",
    "xorg-kbproto==1.0.7",
    "xorg-libice==1.0.10",
    "xorg-libsm==1.2.3",
    "xorg-libx11==1.8.4",
    "xorg-libxau==1.0.9",
    "xorg-libxdmcp==1.1.3",
    "xorg-libxext==1.3.4",
    "xorg-libxrender==0.9.10",
    "xorg-renderproto==0.11.1",
    "xorg-xextproto==7.3.0",
    "xorg-xproto==7.0.31",
    "xz==5.2.6",
    "yarl==1.8.2",
    "zipp==3.15.0",
    "zlib==1.2.13",
    "zstd==1.5.2"
    ## main packages (included above)
    #"tensorflow==2.10.0",
    #"tensorflow-hub==0.12.0",
    #"requests==2.28.1",
    #"scipy==1.7.3",
    #"pandas==1.3.5",
    #"pillow==9.2.0",
    #"pydot==1.4.2",
    #"numpy==1.22.4",
    #"h5py==3.7.0",
    #"keras==2.10.0"
)

if (basilisk.utils::isLinux()) {
    .orthos_dependencies <- c(
        .orthos_dependencies, 
        ## not available for mac/windows
        "_openmp_mutex==4.5",
        "libgcc-ng==13.1.0",
        "libgfortran-ng==13.1.0",
        "libgomp==13.1.0",
        "libstdcxx-ng==13.1.0",
        ## not sure whether the cuda packages need to be compatible with the 
        ## system libraries, so it may be safer to let this be automatically 
        ## decided
        #"cudatoolkit==11.8.0",
        #"cudnn==8.4.1.50",
        "keyutils==1.6.1",
        "libnsl==2.0.0",
        "_libgcc_mutex==0.1",
        "libgfortran5==13.1.0",
        "ncurses==6.4",
        "ld_impl_linux-64==2.40",
        "readline==8.2",
        "libnghttp2==1.51.0",
        "libuuid==2.38.1",
        "gtk2==2.24.33",
        "libtool==2.4.7",
        "libev==4.33",
        "libedit==3.1.20191231",
        ## different versions installed for different operating systems if 
        ## versions not pinned
        "atk-1.0==2.38.0",
        "flatbuffers==2.0.8",
        "gdk-pixbuf==2.42.10",
        "graphite2==1.3.13",
        "graphviz==7.1.0",
        "grpc-cpp==1.47.1",
        "grpcio==1.47.1",
        "harfbuzz==6.0.0",
        "icu==70.1",
        "libcurl==7.87.0",
        "libprotobuf==3.21.12",
        "librsvg==2.54.4",
        "libwebp==1.3.2",
        "libwebp-base==1.3.2",
        "numexpr==2.8.4",
        "pango==1.50.14",
        "pixman==0.40.0",
        "protobuf==4.21.12"
    )
} else if (basilisk.utils::isWindows()) {
    .orthos_dependencies <- c(
        .orthos_dependencies, 
        "_tflow_select==2.3.0",
        "colorama==0.4.6",
        "flatbuffers==23.5.26",
        "getopt-win32==0.1",
        "glib==2.76.2",
        "glib-tools==2.76.2",
        "graphite2==1.3.14",
        "graphviz==4.0.0",
        "grpc-cpp==1.48.1",
        "grpcio==1.48.1",
        "harfbuzz==4.3.0",
        "icu==58.2",
        "libcurl==8.1.2",
        "libflang==5.0.0",
        "libprotobuf==3.20.3",
        "libwebp==1.2.4",
        "libwebp-base==1.2.4",
        "llvm-meta==5.0.0",
        "m2w64-gcc-libgfortran==5.3.0",
        "m2w64-gcc-libs==5.3.0",
        "m2w64-gcc-libs-core==5.3.0",
        "m2w64-gmp==6.1.0",
        "m2w64-libwinpthread-git==5.0.0.4634.697f757",
        "msys2-conda-epoch==20160418",
        "numexpr==2.8.4",
        "openmp==5.0.0",
        "pango==1.50.7",
        "pixman==0.38.0",
        "protobuf==3.20.3",
        "ucrt==10.0.22621.0",
        "vc==14.3",
        "vc14_runtime==14.36.32532",
        "vs2015_runtime==14.36.32532",
        "win_inet_pton==1.1.0"
    )
} else if (basilisk.utils::isMacOSX()) {
    ## tested on both intel and arm
    .orthos_dependencies <- c(
        .orthos_dependencies, 
        "atk-1.0==2.38.0",
        "flatbuffers==2.0.8",
        "gdk-pixbuf==2.42.10",
        "graphite2==1.3.13",
        "graphviz==7.1.0",
        "grpc-cpp==1.47.1",
        "grpcio==1.47.1",
        "gtk2==2.24.33",
        "harfbuzz==6.0.0",
        "icu==70.1",
        "libcurl==7.87.0",
        "libcxx==16.0.6",
        "libedit==3.1.20191231",
        "libev==4.33",
        "libgfortran==5.0.0",
        "libgfortran5==13.2.0",
        "libnghttp2==1.51.0",
        "libprotobuf==3.21.12",
        "librsvg==2.54.4",
        "libtool==2.4.7",
        "libwebp==1.2.4",
        "libwebp-base==1.2.4",
        "llvm-openmp==16.0.6",
        "ncurses==6.4",
        "numexpr==2.8.4",
        "pango==1.50.14",
        "pixman==0.40.0",
        "protobuf==4.21.12",
        "readline==8.2"
    )
}

#' @author Charlotte Soneson
#'
#' @importFrom basilisk BasiliskEnvironment
orthosenv <- basilisk::BasiliskEnvironment(
    envname = "orthos", pkgname = "orthos",
    packages = .orthos_dependencies,
    channels = "conda-forge"
)
